// DDrawWrapper.cpp : Defines the exported functions for the DLL application.
//

#include "stdafx.h"


typedef HRESULT(__stdcall *Draw)(GUID* guid, LPDIRECTDRAW* lplpDD, IUnknown* pUnkOuter);


extern "C"
HRESULT __stdcall OrgDirectDrawCreate(GUID* guid, LPDIRECTDRAW* lplpDD, IUnknown* pUnkOuter)
{
	char syspath[MAX_PATH];
	SHGetSpecialFolderPathA(0, syspath, CSIDL_SYSTEM, FALSE);
	std::string S(syspath);
	S += "\\ddraw.dll";

	HINSTANCE ddlib;
	Draw DDCreateAddr;

	// Wrap to original DDraw function
	ddlib = LoadLibraryA(S.c_str());
	if (ddlib != NULL)
	{
		DDCreateAddr = (Draw)GetProcAddress(ddlib, "DirectDrawCreate");
		if (DDCreateAddr != NULL)
			return DDCreateAddr(guid, lplpDD, pUnkOuter);
	}


	return 0;
}